



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用Python实现子区域数据分类统计</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用Python实现子区域数据分类统计</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 02:01:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>目录</h1>
<ol><li><a href="#%E4%B8%80%E5%89%8D%E8%A8%80" rel="external nofollow noreferrer">前言</a></li>
<li><a href="#%E4%BA%8Cgeopandas%E7%AE%80%E4%BB%8B" rel="external nofollow noreferrer">geopandas简介</a></li>
<li><a href="#%E4%B8%89%E5%AD%90%E5%8C%BA%E5%9F%9F%E6%95%B0%E6%8D%AE%E5%88%86%E7%B1%BB%E7%BB%9F%E8%AE%A1" rel="external nofollow noreferrer">子区域数据分类统计</a></li>
<li><a href="#%E5%9B%9B%E6%80%BB%E7%BB%93" rel="external nofollow noreferrer">总结</a></li></ol>
<h1>一、前言</h1>
<p>       最近碰到一个需求，需要统计某省内的所有市的某数据分布情况信息。现有该省的数据分布情况以及该省的行政区划数据。我通过geopandas库实现了这一需求，在这里简单记录之，供需要的人借鉴。</p>
<h1>二、geopandas简介</h1>
<p>想必大家对<a href="https://github.com/pandas-dev/pandas" rel="external nofollow noreferrer">pandas</a>都不陌生，它是一个开源的强大的Python数据分析工具。pandas确实做到了灵活、快速、高效的进行数据处理，而<a href="https://github.com/geopandas/geopandas" rel="external nofollow noreferrer">geopandas</a>是在pandas的基础上添加了对空间数据的支持，实现了读取空间数据以及对空间数据进行处理。关于其介绍和安装等请参考其github主页，本文不再赘述。</p>
<h1>三、子区域数据分类统计</h1>
<p>       直接进入正题，现有某省的分类统计数据shp文件以及此省的行政区划数据shp文件。</p>
<h2>3.1 引入geopandas</h2>
<p>       为了使用geopandas库，首先需要将其引入。代码如下：</p>
<pre class="prettyprint linenums"><code>from geopandas import *<br />
</code></pre>
<h2>3.2 读取此省分类统计数据及行政区划数据</h2>
<p>       然后从该省的分类统计数据shp文件中读出此数据。代码如下：</p>
<pre class="prettyprint linenums"><code>provincedata = GeoDataFrame.from_file(provinceshpfile)<br />
</code></pre>
<p>       代码很简单，只要给GeoDataFrame.from_file函数传入shp文件路径即可，其得到的是一个GeoDataFrame对象，类似于pandas中的DataFrame，区别会在下文讲到。同理，行政区划数据通过以下代码读入：</p>
<pre class="prettyprint linenums"><code>regiondata = GeoDataFrame.from_file(regionshppath)<br />
</code></pre>
<h2>3.3 投影转换</h2>
<p>       要使上述两个数据能够进行处理必须先要将其转换成相同的投影。geopandas进行投影转换很简单。代码如下：</p>
<pre class="prettyprint linenums"><code>gpd_new=gpd.to_crs(crs)<br />
</code></pre>
<p>       其中gpd表示原始数据，gpd_new为转换后的数据，crs表示需要转换的投影参数，在<a href="https://github.com/geopandas/geopandas/blob/46e50fe5a772944b325bc3c8806f4f96da76a0d8/doc/source/projections.rst" rel="external nofollow noreferrer">https://github.com/geopandas/geopandas/blob/46e50fe5a772944b325bc3c8806f4f96da76a0d8/doc/source/projections.rst</a>中对此参数进行了详细描述，大家可以参照。</p>
<p>       所以我们只需要将上述两种数据转换到同一投影即可，问题是假设我们不知道它们的投影类型，那么也很容易，只需要将其都转换成4326或其他投影即可，这样就能保证二者转换后为同一投影。但是问题又来了，如果该省分类数据特别大将会导致投影转换耗时过长。其实此处有个简单方法，我们只需要读出分类数据的crs并将行政区划数据转换成此投影即可，这样不仅代码简单而且能够节省大量时间。代码如下：</p>
<pre class="prettyprint linenums"><code>regiondata_crs = regiondata.to_crs(provincedata.crs)<br />
</code></pre>
<h2>3.4 对该省逐市进行数据分类提取</h2>
<p>       现在二者投影已经相同，我们不得不面对最核心的问题，如何能够从省的分类数据中提取出逐市分类数据情况。我们可以想到必须要将每个市的空间数据与该省的所有分类数据进行相交判断，判断哪些分类数据与该市相交，然后完成相应处理。</p>
<h3>3.4.1 获取市的空间数据</h3>
<p>首先对行政区划数据进行循环得到每个市的空间数据。代码如下：</p>
<pre class="prettyprint linenums"><code>for i in range(0, len(regiondata_crs)):<br />
    geo = regiondata_crs.geometry[i]<br />
    name = regiondata_crs.NAME[i]<br />
</code></pre>
<p>       其中geo就是取到的当前市的空间数据，可以看出GeoDataFrame与DataFrame的区别就在于多了一个geometry字段，它包含了数据的空间信息，可以对该字段进行空间操作。假设该shp文件还包含了一个NAME属性，那么我们就可以用“.NAME”的方式提取出当前市的name数据，其他属性同理。</p>
<h3>3.4.2 获取此空间内的分类数据信息</h3>
<p>       有了geo之后就可以将其与省的分类数据中的每一个对象进行相交判断（循环判断），根据结果进行相应处理。这里我们假设统计不同种类数据的面积值，即每种类型的数据在该市所占面积大小。代码如下：</p>
<pre class="prettyprint linenums"><code>area = {}<br />
for i in range(0, len(provincedata)):<br />
    geo_province = provincedata.geometry[i]<br />
    id = str(provincedata.ID[i])<br />
    if geo_province.intersects(geo) and geo_province.is_valid :<br />
        temp_geo = geo_province.intersection(geo)<br />
        temp_area = temp_geo.area<br />
        if area.get(id) == None:<br />
            area[id] = temp_area<br />
        else :<br />
            area[id] = area.get(id) + temp_area<br />
</code></pre>
<p>       其中area为字典对象，用来存储不同数据在该市所占面积。</p>
<p>       首先通过provincedata.geometry[i]获取该数据的空间信息geo_province，然后使用provincedata.ID[i]取出该数据的编号值id。</p>
<p>       geo_province.intersects(geo)用来判断该数据与当前市（geo）在空间上是否相交，geo_province.is_valid用来判断该数据是否合法，有无自相交环等。</p>
<p>       如果相交则进行处理，首先通过geo_province.intersection(geo)来获取相交的部分temp_geo，然后通过temp_geo.area获取相交部分的面积temp_area。可以看出在geopandas中只需要对geometry对象使用area属性即可获取其面积。</p>
<p>       最后将面积以id为key保存到area字典当中。</p>
<h1>四、总结</h1>
<p>       这样就可以实现对该省的分类统计数据进行进一步细分，取出每个市的数据分类信息。当然并一定局限于省和市，比如全球和国家或者国家和省等。只要存在包含关系即可通过此种方式进行处理。这是鸡年的第一篇博客，愿所有人今年都能有个好的结果！</p>
<hr>
<p>打个广告，年初我与朋友成立了一家公司，现长期招聘，如下：</p>
<p><strong>公司名称：</strong>武汉一格空间科技有限公司<br /><br />
<strong>官网主页：</strong><a href="http://www.phitrellis.com" rel="external nofollow noreferrer">http://www.phitrellis.com</a><br /><br />
<strong>公司简介：</strong>我们是一家初创公司，专注于地理信息系统，目前方向为研发一套地信大数据管理、可视化、分析平台<br /><br />
<strong>工作地址：</strong>甘肃兰州<br /><br />
<strong>招聘岗位：</strong>前端、后端均可<br /><br />
<strong>职位要求：</strong>没有特殊要求，只要你有能力，有拼搏进取的精神，能吃苦、肯学、肯上进，愿意与公司共同成长，我们都很欢迎<br /><br />
<strong>技术框架：</strong>前端主要用到React，后端主要用到Python、Scala，包含数据处理（numpy、pandas）、地信基础分析（geopandas、rasterio等）、Hadoop\Spark分布式框架。<br /><br />
<strong>薪资待遇：</strong>薪资面议，只要你足够优秀，我们愿意提供相应的薪资，公司各项福利优厚，工作环境宽松，不强制996，个人爱好和兴趣驱动。<br /><br />
<strong>联系方式：</strong>可以直接通过博客园联系，或Email：shoufengwei@phitrellis.com</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwjepl8.html">快速上手seajs&mdash;&mdash;简单易用Seajs</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqllrp6q.html">ADO&period;net 更新和插入数据 遇到null 执行不成功</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1pn1zq.html">求android ble 解决方案！</a>
		</li>
						<li><a href="https://www.batexi.com/a/r9341r08.html">王爽-汇编语言-综合研究一-搭建简易C环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j5xpl8.html">用R语言分析我的fitbit计步数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw1nvy8.html">ubuntu apt-get修改源地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm6wo79.html">ERROR 2003 &lpar;HY000&rpar;&colon; Can&amp;&num;39&semi;t connect to MySQL server</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xm4109.html">PHP批量审核ajax jquery</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yoxe08.html">&lbrack;cocos2d-x&rsqb;用CCSpriteBatchNode进行文理贴图的优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zngd39.html">Weex系列二、显示图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jy01l8.html">LeetCode 27&period; Remove Element （移除元素）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp6ol39.html">USACO Humble Numbers</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj714z8.html">在dotnetcore的MVC项目中，创建支持 vue&period;js 的最小工程模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdw3vz9.html">JS获取伪元素的属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o143v5q.html">查看iPhone电池寿命</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvx4lg8.html">English trip V1 - 12&period;Belongings 行李 Teacher&colon;Jade Key&colon; ？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwr2oy8.html">MySQL中的视图详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/93we3wrq.html">react input的几个坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjlor09.html">ionic 图片轮播ion-slide-box问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kojde5q.html">【Linux】双向重导向命令tee</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8melk26q.html">【转】amCharts，一款值得推荐的Flash charts图组件</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgy7ed8.html">部分网站允许空白referer的防盗链图片的js破解代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zor62nq.html">使用SSH搭建用户注册登录系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey5r0j9.html">java判断是否为汉字</a>
			</li>
						<li><a href="https://www.batexi.com/a/950mygm8.html">MyEclipse 显示行标</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpn4539.html">jQuery对象插件封装步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgy3y78.html">连锁不平衡LD</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zm2k09.html">在官网下载了最新版的PHP，解压后的安装包里为什么没有php5isapi&period;dll这个dll文件？</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy14llgq.html">3&period; 托管对象模型的迁移（Core Data 应用程序实践指南）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkojez8.html">HDU-2502-月之数</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
